<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.ruoyi.predict.mapper.WfTheoryenergyDataMapper">
    
    <resultMap type="WfTheoryenergyData" id="WfTheoryenergyDataResult">
        <result property="windplantNo"    column="windplant_no"    />
        <result property="dataTime"    column="data_time"    />
        <result property="theoryenergy"    column="theoryenergy"    />
        <result property="availableenergy"    column="availableenergy"    />
        <result property="dataFlag"    column="data_flag"    />
    </resultMap>

    <sql id="selectWfTheoryenergyDataVo">
        select windplant_no, data_time, theoryenergy, availableenergy, data_flag from wf_theoryenergy_data
    </sql>

    <select id="selectWfTheoryenergyDataList" parameterType="WfTheoryenergyData" resultMap="WfTheoryenergyDataResult">
        <include refid="selectWfTheoryenergyDataVo"/>
        <where>  
            <if test="windplantNo != null "> and windplant_no = #{windplantNo}</if>
            <if test="theoryenergy != null "> and theoryenergy = #{theoryenergy}</if>
            <if test="availableenergy != null "> and availableenergy = #{availableenergy}</if>
            <if test="dataFlag != null "> and data_flag = #{dataFlag}</if>
            <if test="params.beginDataTime != null and params.beginDataTime != '' and params.endDataTime != null and params.endDataTime != ''">
                and data_time between to_date(#{params.beginDataTime},'yyyy-MM-dd HH24:MI:SS') and
                to_date(#{params.endDataTime},'yyyy-MM-dd HH24:MI:SS')
            </if>
            <if test="dataTime != null ">and data_time = #{dataTime}</if>
        </where>
    </select>
    
    <select id="selectWfTheoryenergyDataById" parameterType="Long" resultMap="WfTheoryenergyDataResult">
        <include refid="selectWfTheoryenergyDataVo"/>
        where windplant_no = #{windplantNo}
    </select>

    <select id="selectWfTheoryenergyData" parameterType="WfTheoryenergyData" resultMap="WfTheoryenergyDataResult">
        <include refid="selectWfTheoryenergyDataVo"/>
        where windplant_no = #{windplantNo} and data_time > #{dataTime}
    </select>

    <insert id="insertWfTheoryenergyData" parameterType="WfTheoryenergyData">
        insert into wf_theoryenergy_data
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="windplantNo != null">windplant_no,</if>
            <if test="dataTime != null">data_time,</if>
            <if test="theoryenergy != null">theoryenergy,</if>
            <if test="availableenergy != null">availableenergy,</if>
            <if test="dataFlag != null">data_flag,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="windplantNo != null">#{windplantNo},</if>
            <if test="dataTime != null">#{dataTime},</if>
            <if test="theoryenergy != null">#{theoryenergy},</if>
            <if test="availableenergy != null">#{availableenergy},</if>
            <if test="dataFlag != null">#{dataFlag},</if>
         </trim>
    </insert>

    <update id="updateWfTheoryenergyData" parameterType="WfTheoryenergyData">
        update wf_theoryenergy_data
        <trim prefix="SET" suffixOverrides=",">
            <if test="dataTime != null">data_time = #{dataTime},</if>
            <if test="theoryenergy != null">theoryenergy = #{theoryenergy},</if>
            <if test="availableenergy != null">availableenergy = #{availableenergy},</if>
            <if test="dataFlag != null">data_flag = #{dataFlag},</if>
        </trim>
        where windplant_no = #{windplantNo}
    </update>

    <delete id="deleteWfTheoryenergyDataById" parameterType="Long">
        delete from wf_theoryenergy_data where windplant_no = #{windplantNo}
    </delete>

    <delete id="deleteWfTheoryenergyDataByIds" parameterType="String">
        delete from wf_theoryenergy_data where windplant_no in 
        <foreach item="windplantNo" collection="array" open="(" separator="," close=")">
            #{windplantNo}
        </foreach>
    </delete>
</mapper>